//+------------------------------------------------------------------+
//|                                             WPR of Kijun Sen.mq4 |
//|                                                           Jas Wu |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------
#property strict
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_label1  "Wpr of Kijun Sen"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrSeaGreen
#property indicator_width1  2

input int    WprPeriod = 35;   // WPR Period
input int    Kijun     = 26;   // Kijun Period
input double UpLevel   = -20;  // Up Level
input double DnLevel   = -80;  // Dn Level

double wpr[],ks[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int OnInit()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,wpr,INDICATOR_DATA);
   SetIndexBuffer(1,ks);
 
   SetLevelValue(0, UpLevel);
   SetLevelValue(1, DnLevel);
   SetLevelStyle(STYLE_DOT, 1); 
   
   IndicatorSetString(INDICATOR_SHORTNAME," WPR of Kijun Sen");
return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int  OnCalculate(const int rates_total,const int prev_calculated,const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int i=rates_total-prev_calculated+1; if (i>=rates_total) i=rates_total-1;
   
   //
   //
   //
   
   for (; i>=0 && !_StopFlag; i--)
   {
      double klo =  low[ArrayMinimum(low, Kijun,i)];
      double khi = high[ArrayMaximum(high,Kijun,i)];
         ks[i]   = ((khi+klo)!=0) ? (khi+klo)*0.5 : 0;
         
      double hi = ks[ArrayMaximum(ks,WprPeriod,i)];
      double lo = ks[ArrayMinimum(ks,WprPeriod,i)];
         wpr[i] = (hi!=lo) ? -100*(hi-ks[i])/(hi-lo) : 0;
   }
return(rates_total);
}
